#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Area of Faces
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Face Tool>Area of Faces
#		 Note:	
#    Date:	Mar 2015
#------------------------------------------------------------------------------------------------
require 'sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item("Area of Faces") { SDM::area_of_faces }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	def SDM.area_of_faces
		mod=Sketchup.active_model;
		ent=mod.active_entities;
		sel=mod.selection
		sel.empty? ? ents=ent.to_a : ents=sel.to_a
		@tot_area = 0.0; self.find_faces(ents)
		UI.messagebox "Total area of faces = #{Sketchup.format_area(@tot_area)}"
	end
	
	def self.find_faces(ents)
		for e in ents
			if e.is_a? Sketchup::Face
				@tot_area += e.area
			elsif e.is_a? Sketchup::Group
				self.find_faces(e.entities)
			elsif e.is_a? Sketchup::ComponentInstance
				self.find_faces(e.definition.entities)
			end
		end
	end
	
end
